<?xml version="1.0" encoding='koi8-r'?>
<xsl:stylesheet version="1.0" 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:exsl="http://exslt.org/common" 
  exclude-result-prefixes="exsl">

<!-- $Id: collect_authors.xsl,v 1.7 2003/08/10 14:53:29 vyt Exp $ -->

<!--
	      .
	       .

               
     ̣  "collect-authors-container", .   html 
       .

	      
	by Anton V. Boyarshinov <boyarsh@ru.echo.fr>
-->

<xsl:param name="firstname.short" select="0"/>

<!--    author, editor  ..,  .
         . -->
<xsl:template name="person.name">
  <xsl:param name="node" select="."/>
  <!--       -->
  <xsl:choose>
    <!--        ݣ ,  -->
    <xsl:when test="$firstname.short">
      <!--         ,   -->
      <xsl:value-of select="substring($node/firstname,1,1)"/>
      <xsl:text>.</xsl:text>
    </xsl:when>
    <xsl:otherwise>
      <xsl:value-of select="$node/firstname"/>
    </xsl:otherwise>
  </xsl:choose>
  <xsl:text>&#x00A0;</xsl:text>
  <xsl:value-of select="$node/surname"/>
</xsl:template>

<!--     -    -->
<xsl:template match="author" mode="titlepage.mode"/>

<!--   -->
<xsl:template name="collect-authors">
  <!--         ,    
           'info'   -->
  <xsl:variable name="authors">
    <xsl:choose>
      <!--  title  subtitle,     ,   bookinfo,
             ߣ  book     .    book  . 
            book   ,       . -->
      <xsl:when test="contains(local-name(..),'info')">
        <xsl:for-each select="../../descendant::author[contains(local-name(..),'info') or contains(local-name(../..),'info')]">
          <xsl:sort select="surname"/>
          <xsl:sort select="firstname"/>
          <!-- FIXME:    -->
          <xsl:copy-of select="."/>
        </xsl:for-each>
      </xsl:when>
      <!--  title  subtitle    book,        
             -->
      <xsl:otherwise>
        <xsl:for-each select="../descendant::author[contains(local-name(..),'info') or contains(local-name(../..),'info')]">
          <xsl:sort select="surname"/>
          <xsl:sort select="firstname"/>
          <!-- FIXME:    -->
          <xsl:copy-of select="."/>
        </xsl:for-each>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:variable>
  <xsl:for-each select="exsl:node-set($authors)/author">
    <!-- FIXME: ,      exsl:node-set()      libxslt -->
    <xsl:sort select="surname"/>
    <xsl:sort select="firstname"/>
    <!-- FIXME: ,     preceding-sibling   preceding 
              libxslt-1.0.30-alt2 -->
    <xsl:if test="(preceding-sibling::author[1]/firstname != firstname) or 
                  (preceding-sibling::author[1]/surname != surname) or position()=1">
      <!--     ,     -->
      <xsl:if test="position()!=1">
        <xsl:text>, </xsl:text>
      </xsl:if>
      <!--    -->
      <xsl:call-template name="person.name"/>
    </xsl:if>
  </xsl:for-each>
</xsl:template>

<!--     ,   . -->
<xsl:template match="title" mode="titlepage.mode">
  <!--    -->
  <xsl:apply-imports/>
  <!--   ,       -->
  <!--  bookinfo   subtitle  title,    
       subtitle    -->
  <xsl:if test="not(following-sibling::subtitle|preceding-sibling::subtitle)">
    <!--       -->
    <xsl:call-template name="collect-authors-container"/>
  </xsl:if>
</xsl:template>

<xsl:template match="subtitle" mode="titlepage.mode">
  <xsl:apply-imports/>
  <!--   ,      -->
  <xsl:call-template name="collect-authors-container"/>
</xsl:template>

<!--     -->
<!--
<xsl:template name="collect-authors-container">
  <div class="author">
    <h3 class="author">
      <xsl:call-template name="collect-authors"/>
    </h3>
  </div>
</xsl:template>
-->

</xsl:stylesheet>
