<?xml version='1.0' encoding="windows-1251"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:alt="http://docs.altlinux.ru"
                version='1.0'>

<xsl:import href="http://docbook.sourceforge.net/release/xsl/current/html/chunker.xsl"/>

<xsl:param name="chunk.quietly" select="0"/>

<xsl:param name="doc-filename"><xsl:value-of select="//alt:doc-filename[1]"/></xsl:param>

<xsl:param name="doc-doctype-public">
  <xsl:choose>
    <xsl:when test="//alt:doc-doctype-public[1]">
      <xsl:value-of select="//alt:doc-doctype-public[1]"/>
    </xsl:when>
    <xsl:otherwise>
      <xsl:value-of select="'-//ALTLINUX//DTD DocBook XML Based Extension//EN'"/>
    </xsl:otherwise>
  </xsl:choose>
</xsl:param>

<xsl:param name="doc-doctype-system">
  <xsl:choose>
    <xsl:when test="//alt:doc-doctype-system[1]">
      <xsl:value-of select="//alt:doc-doctype-system[1]"/>
    </xsl:when>
    <xsl:otherwise>
      <xsl:value-of select="'http://docs.altlinux.ru/dtd/docs.dtd'"/>
    </xsl:otherwise>
  </xsl:choose>
</xsl:param>

<xsl:param name="doc-encoding">windows-1251</xsl:param>

<xsl:param name="code-filename"><xsl:value-of select="//alt:code-filename[1]"/></xsl:param>
<xsl:param name="code-encoding">windows-1251</xsl:param>
<xsl:param name="code-output-method"><xsl:value-of select="//alt:code-output-method[1]"/></xsl:param>

<!-- FIXME: vyt - add possibility for specifying this param from source litprog -->
<xsl:param name="root-tag">section</xsl:param>

<xsl:template match="alt:doc" mode="doc">
  <xsl:copy-of select="*">
    <xsl:apply-templates mode="doc"/>
  </xsl:copy-of>
</xsl:template>

<xsl:template match="alt:code" mode="doc">
  <xsl:element name="programlisting">
    <xsl:value-of select="."/>
  </xsl:element>
</xsl:template>

<xsl:template match="node()" mode="doc">
  <xsl:apply-templates mode="doc"/>
</xsl:template>

<xsl:template match="alt:code" mode="code">
  <xsl:copy-of select=".">
    <xsl:apply-templates mode="code"/>
  </xsl:copy-of>
</xsl:template>

<xsl:template match="node()" mode="code">
  <xsl:apply-templates mode="code"/>
</xsl:template>


<xsl:template match='/'>
  <!-- FIXME: vyt - add check for filenames present -->
  <xsl:call-template name="write.chunk">
    <xsl:with-param name="filename" select="$doc-filename"/>
    <xsl:with-param name="method" select="'xml'"/>
    <xsl:with-param name="encoding" select="$doc-encoding"/>
    <xsl:with-param name="doctype-public" select="$doc-doctype-public"/>
    <xsl:with-param name="doctype-system" select="$doc-doctype-system"/>
    <xsl:with-param name="content">
      <xsl:element name="{$root-tag}">
        <xsl:apply-templates mode="doc"/>          
      </xsl:element>
    </xsl:with-param>
    <xsl:with-param name="quiet" select="$chunk.quietly"/>
  </xsl:call-template>

  <xsl:call-template name="write.chunk">
    <xsl:with-param name="filename" select="$code-filename"/>
    <xsl:with-param name="method" select="$code-output-method"/>
    <xsl:with-param name="encoding" select="$code-encoding"/>
    <xsl:with-param name="content">
      <alt:doc-root>
        <xsl:apply-templates mode="code"/>
      </alt:doc-root>
    </xsl:with-param>
    <xsl:with-param name="quiet" select="$chunk.quietly"/>
  </xsl:call-template>

</xsl:template>

</xsl:stylesheet>
